require 'soap/response_cutter/version'
require 'active_support/core_ext/hash'

module Soap
  #         Those are a crazy duplication and calls for some really ugly hacks
  #         to get the data you are reall interested in. Fuck SOAP!
  #
  # Examples:
  #   ResponseCutter.new(:soap_action, { somes: 'value'})
  class ResponseCutter
    DeepShit = Class.new(StandardError)
    USELESS_KEYS = %w(response result return)
    attr_reader :action, :response

    def initialize(action, response)
      @action = action
      @response = response.respond_to?(:body) ? response.body : response
      @response = response.dup.deep_symbolize_keys!
    end

    def parse
      catch :done do
        safe_guard = 0
        while useless_nesting?
          flatten_response
          safe_guard += 1
          throw :done if safe_guard > 3
        end
      end
      response.blank? ? true : response
    end

    private

    # rubocop:disable AbcSize
    def flatten_response
      USELESS_KEYS.each do |suffix|
        @response = response.fetch(key(suffix)) do
          response.fetch(reverse_key(suffix)) { response }
        end
        throw :done unless response.is_a?(Hash)
        clear_xmlns_keys
        throw :done unless useless_nesting?
      end
    end
    # rubocop:enable AbcSize

    def clear_xmlns_keys
      response.delete_if { |k| k.to_s =~ /xmlns/ }
    end

    def useless_nesting?
      response.any? { |k| k.to_s =~ /response|result|return/ }
    end

    def key(suffix)
      act = "#{action}"
      version_pattern = /_v(\d)/
      if act =~ version_pattern
        version = act[version_pattern]
        act = act.gsub(version_pattern, '')
        return "#{act}_#{suffix}#{version}".to_sym
      end

      reverse_key(suffix)
    end

    def reverse_key(suffix)
      "#{action}_#{suffix}".to_sym
    end
  end
end
